// IniFile.cpp: Implementierung der Klasse CIniFile.
//
////////////////////////////////////////////////////////////////////////////////////////

#include "IniFile.h"

////////////////////////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
////////////////////////////////////////////////////////////////////////////////////////
CIniFile::CIniFile()
{
	// Standartwerte setzen
	datei = 0;
	first_kay = 0;
	a_kay = 0;
	a_wert = 0;
	error = 0;

	// Dateinamen speichern
	strncpy(this->filename,"test.ini",INI_LEN_FILENAME+1);
}

CIniFile::CIniFile(char* filename)
{
	// Standartwerte setzen
	datei = 0;
	first_kay = 0;
	a_kay = 0;
	a_wert = 0;
	error = 0;

	// Dateinamen speichern
	strncpy(this->filename,filename,INI_LEN_FILENAME+1);
	
	// Datei zum lesen ffnen
	if (open('r'))
	{
		// Daten einlesen
		lese_ini();
		// Datei wieder schlieen
		close();
	}
	else error=1;
}

CIniFile::~CIniFile()
{
	close();
	del_all();
}

////////////////////////////////////////////////////////////////////////////////////////
// Funktionen zum ffnen, schlieen und speichern einer Ini-Datei
////////////////////////////////////////////////////////////////////////////////////////
bool CIniFile::open(char typ)
{
	// wenn noch eine Datei geffent ist, diese schlieen
	if(datei) close();

	char art[2];
	art[0] = typ;
	art[1] = 0;

	// Ini-Datei ffnen
	datei = fopen( filename, art );

	// wenn die Ini-datei nicht vorhanden ist, prog beenden
	if (datei<=0)
	{
		fprintf(stderr,"Ini-Datei %s konnte nicht gefunden werden!\n",filename);
		return false;
	}

	return true;
}

void CIniFile::close()
{
	// Wenn eine Datei geffnet ist, diese schlieen
	if (datei)
	{
		fclose(datei);
		datei=0;
	}
}

void CIniFile::save(char* newfilename)
{
	// neuen Dateinamen Speichern
	if (newfilename) strncpy(this->filename,newfilename,INI_LEN_FILENAME+1);

	// zum schreiben ffnen
	open('w');

	// Daten schreiben
	schreibe_ini();

	// Datei wieder schlieen
	close();
}

void CIniFile::del_all()
{
	// Zum zwischenspeichern der Pointer zum nchsten element
	strKay* n_kay;
	strWert* n_wert;
	
	a_kay=first_kay;
	// alle Schlssel lschen
	while(a_kay)
	{
		a_wert=a_kay->werte;
		// alle werte des Schlssels lschen
		while(a_wert)
		{
			n_wert = a_wert->next_wert;
			delete a_wert;
			a_wert = n_wert;
		}
		n_kay = a_kay->next_kay;
		delete a_kay;
		a_kay = n_kay;
	}
	first_kay=0;
}

////////////////////////////////////////////////////////////////////////////////////////
// Hilfsfunktionen zum schreiben/lesen der daten einer *.ini
////////////////////////////////////////////////////////////////////////////////////////
void CIniFile::schreibe_ini()
{
	// von Anfang an ausgeben
	a_kay=first_kay;

	// Schlssel ausgeben
	while(a_kay)
	{
		// Name des Schlssels
		fprintf(datei,"[%s]\n",a_kay->name);
		
		// anfang der Wertliste
		a_wert=a_kay->werte;

		// Werte des Schlssels ausgeben
		while(a_wert)
		{
			// Name des Schlssels, und sein Wert
			fprintf(datei,"%s=%s\n",a_wert->name,a_wert->wert);

			// nchster Wert
			a_wert=a_wert->next_wert;
		}

		fprintf(datei,"\n");

		// nchster Schlssel
		a_kay=a_kay->next_kay;
	}
}

void CIniFile::lese_ini()
{
	// ist berhaupt eine datei gffnet?
	if(datei<=0) return;

	// zwischenspeicher
	int i=0,j=0;
	char tmp[INI_INPUT_PUFFER]={0};
	char name[INI_LEN_PUFFER_NAME]={0};
	char wert[INI_LEN_WERT]={0};

	// an den Dateianfang springen
	fseek(datei,SEEK_SET,0);

	// jede zeile der datei in tmp einlesen -> fscanf() liefert 0 bei dateiende
	while(fgets(tmp,INI_INPUT_PUFFER,datei))
	{
		// # -> Kommentar in der Ini
		if(tmp[0]=='#') continue;

		i=0;
		// eingelesen zeilenumbruch entfernen
		while(tmp[i]&&tmp[i]!='\n')i++;
		tmp[i]=0;

		// Fallunterscheidung (Kay oder Wert)
		if(tmp[0]=='[')
		{
			i=1;
			// Kay
			while((tmp[i]!=']')&&(tmp[i])&&(i<INI_LEN_PUFFER_NAME-2))
			{
				name[i-1]=tmp[i];
				i++;
			}
			name[i-1]=0;
			new_kay(name);
		}
		else if(strchr(tmp,'='))
		{
			i=j=0;
			// Wert
			while((tmp[i]!='=')&&(tmp[i])&&(i<INI_LEN_PUFFER_NAME-2))
			{
				name[i]=tmp[i];
				i++;
			}
			name[i]=0;
			i++;
			while((tmp[i])&&(j<INI_LEN_WERT-1))
			{
				wert[j]=tmp[i];
				i++;j++;
			}
			wert[j]=0;
			new_wert(0,name,wert);
		}

	}

}

////////////////////////////////////////////////////////////////////////////////////////
// Funktionen zum erzeugen von neuen Werten und Schlsseln
////////////////////////////////////////////////////////////////////////////////////////
bool CIniFile::new_kay(char* kayname)
{
	// Schlssel schon da?
	if(suche_kay(kayname))
	{
		fprintf(stderr,"Schlssel %s bereits vorhanden! Es wurde kein neuer angelegt!\n",kayname);
		return false;
	}

	// speicher fr neuen schlssel erzeugen
	strKay* nkay = new strKay;

	if(nkay==0)
	{
		fprintf(stderr,"Fr den Schlssel %s konnte kein Speicher zur verfgung gestellt werden.\n",kayname);
		return false;
	}

	// Schlsselname speichern
	strncpy(nkay->name,kayname,INI_LEN_KAYNAME+1);
	// next_kay=0 da letzter schlssel
	nkay->next_kay=0;
	// werte = 0 da noch keine werte da
	nkay->werte=0;

	// ist es der erste Schlssel
	if(first_kay==0) first_kay=nkay;
	else
	{	// wenn kein aktueller Kay definiert, wird vom Anfang ausgegangen, sonst vom aktuellen
		if(a_kay==0) a_kay=first_kay;
		
		// letzten Schlssel suchen
		while(a_kay->next_kay) a_kay=a_kay->next_kay;

		// neuen Schlssel anhngen
		a_kay->next_kay=nkay;
	}

	// aktueller Schlssel = der gerade erzeugte Schlssel
	a_kay=nkay;

	return true;
}

bool CIniFile::new_wert(char* kayname, char* wertname, char* wert)
{
	// soll der Schlssel gesucht werden
	if(kayname)
	{	// Schlssel da?
		if(!suche_kay(kayname)) return false;
	}
	else
	{	// Kein Schlssel defieniert!
		if(!a_kay) return false;
	}

	// Wert schon da?
	if(suche_wert(wertname))
	{
		fprintf(stderr,"Wert %s bereits vorhanden! Es wurde kein neuer angelegt!\n",wertname);
		return false;
	}

	// Speicher fr neuen Wert zur verfgung stellen
	strWert* nwert = new strWert;

	if(nwert==0)
	{
		fprintf(stderr,"Fr den Wert %s konnte kein Speicher zur verfgung gestellt werden.\n",wertname);
		return false;
	}

	// Wertname speichern
	strncpy(nwert->name,wertname,INI_LEN_WERTNAME+1);
	// next_wert=0 da letzter schlssel
	nwert->next_wert=0;
	// Wert speichern
	strncpy(nwert->wert,wert,INI_LEN_WERT+1);

	// ist es der erste Wert im Schlssel
	if(a_kay->werte==0) a_kay->werte=nwert;
	else
	{	// vom ersten wert des Schlssels ausgehen
		a_wert=a_kay->werte;
		
		// letzten Wert des Schlssels suchen
		while(a_wert->next_wert) a_wert=a_wert->next_wert;

		// neuen Schlssel anhngen
		a_wert->next_wert=nwert;
	}

	// aktueller Schlssel = der gerade erzeugte Schlssel
	a_wert=nwert;

	return true;
}

bool CIniFile::new_wert(char *kayname, char* wertname, int wert)
{
	char tmp[INI_LEN_WERT]={0};
	itoa(wert,tmp,10);
	printf("wert= %s\n",tmp);

	return true;
}

////////////////////////////////////////////////////////////////////////////////////////
// Funktion zum bearbeiten von Werten
////////////////////////////////////////////////////////////////////////////////////////
bool CIniFile::set_wert(char* kayname, char* wertname, char* wert)
{
	if(suche_kay(kayname))
	{
		if(suche_wert(wertname))
		{
			strncpy(a_wert->wert,wert,INI_LEN_WERT+1);
			return true;
		}
		else
		{
			fprintf(stderr,"Wert %s konnte nicht gefunden werden.\n",wertname);
			return false;
		}
	}
	else
	{
		fprintf(stderr,"Schlssel %s konnte nicht gefunden werden.\n",kayname);
		return false;
	}
}

////////////////////////////////////////////////////////////////////////////////////////
// Funktionen zum auslesen von Werten
////////////////////////////////////////////////////////////////////////////////////////
char* CIniFile::get_wert_c(char* kayname, char* wertname)
{
	char* swert=0;

	if(kayname)
	{
		if(suche_kay(kayname))
		{
			if(suche_wert(wertname))
			{
				swert=a_wert->wert;
			}
			else
			{
				fprintf(stderr,"Wert %s konnte nicht gefunden werden.\n",wertname);
			}
		}
		else
		{
			fprintf(stderr,"Schlssel %s konnte nicht gefunden werden.\n",kayname);
		}
	}
	else
	{
		if(a_kay)
		{
			if(suche_wert(wertname))
			{
				swert=a_wert->wert;
			}
			else
			{
				fprintf(stderr,"Wert %s konnte nicht gefunden werden.\n",wertname);
			}
		}
		else
		{
			fprintf(stderr,"Es ist kein Aktueller Schlssel Definiert!\n");
		}
	}


	return swert;
}

int CIniFile::get_wert_i(char* kayname, char* wertname)
{
	char* swert=0;
	int iwert = 0;

	// Pointer zur Zeichenkette des Wertes
	swert = get_wert_c(kayname,wertname);
	
	// ist der Wert berhaupt vorhanden
	if(swert) iwert = atoi(swert);

	return iwert;
}

double CIniFile::get_wert_f(char* kayname, char* wertname)
{
	char* swert=0;
	double fwert = 0;

	// Pointer zur Zeichenkette des Wertes
	swert = get_wert_c(kayname,wertname);

	// ist der Wert berhaupt vorhanden
	if(swert) fwert = atof(swert);

	return fwert;
}

////////////////////////////////////////////////////////////////////////////////////////
// Funktionen zum Suchen von Werten und Schlsseln
////////////////////////////////////////////////////////////////////////////////////////
bool CIniFile::suche_kay(char* kayname)
{
	a_kay=first_kay;
	while(a_kay)
	{
		if(!strcmp(kayname,a_kay->name)) return true;
		a_kay=a_kay->next_kay;
	}

	// wenn kein Schlssel gefunden wurde, wieder auf anfang setzen
	a_kay=first_kay;

	return false;		
}

bool CIniFile::suche_wert(char* wertname)
{
	// ist berhaupt ein Schlssel definiert
	if(!a_kay) return false;

	a_wert=a_kay->werte;
	while(a_wert)
	{
		if(!strcmp(wertname,a_wert->name)) return true;
		a_wert=a_wert->next_wert;
	}

	// wenn kein Wert gefunden wurde, wieder auf anfang setzen
	a_wert=a_kay->werte;

	return false;
}

////////////////////////////////////////////////////////////////////////////////////////
// Funktion zum Anzeigen des Baumes (der Ini-Struktur)
////////////////////////////////////////////////////////////////////////////////////////
void CIniFile::show()
{
	int zeile=0;

	// von Anfang an ausgeben
	a_kay=first_kay;

	// Schlssel ausgeben
	while(a_kay)
	{
		// Name des Schlssels
		fprintf(stdout,"[%s]\n",a_kay->name);
		zeile++;
		
		// anfang der Wertliste
		a_wert=a_kay->werte;

		// Werte des Schlssels ausgeben
		while(a_wert)
		{
			// Name des Schlssels, und sein Wert
			fprintf(stdout," -> %s = \"%s\"\n",a_wert->name,a_wert->wert);
			zeile++;

			// nchster Wert
			a_wert=a_wert->next_wert;
		}

		fprintf(stdout,"\n");

		// nchster Schlssel
		a_kay=a_kay->next_kay;
	}
}