#include <sdl.h>
#include <string.h>
#include "IniFile.h"
#include "particlesys.h"

#ifdef _WIN32
#undef _main
#endif

#define BOOL(x) ((x==0)?false:true)

int main(int argc, char **argv)
{
	// SDL Starten
	if (SDL_Init(SDL_INIT_VIDEO)<0)
	{
		fprintf(stderr,"SDL konnte nicht initialisiert werden: %s\n",SDL_GetError());
		exit(1);
	}

	// Titel und Icon setzten
	SDL_WM_SetCaption("Particel System","Particel System");

	// Ini einlesen
	char filename[100]={0};
	if(argc>1) strcpy(filename,argv[1]);
	else strcpy(filename,"parsys.ini");
	CIniFile init(filename);

	// ist die datei berhaupt da
	if(init.get_error()) exit(1);

	// Werte fr das ParticelSys holen	
	int wert[8]={0};
	wert[0] = init.get_wert_i("PSYS","breite");
	wert[1] = init.get_wert_i("PSYS","hoehe");
	wert[2] = init.get_wert_i("PSYS","schweiflaenge");
	wert[3] = init.get_wert_i("PSYS","richtungen");
	wert[4] = init.get_wert_i("PSYS","farbtiefe");
	wert[5] = init.get_wert_i("PSYS","fullscreen");
	wert[6] = init.get_wert_i("PSYS","zuf_richtungswechsel");
	wert[7] = init.get_wert_i("PSYS","const_geschw");
	
	// ParticelSys starten
	CParticelSys p(wert[0],wert[1],wert[2],wert[3],wert[4],BOOL(wert[5]));
	p.zuf_richtwechsel(BOOL(wert[6]));
	p.const_geschw(BOOL(wert[7]));
	
	// Particel erzeugen
	int pw[4]={0};

	init.goto_firstkay();
	while(init.goto_next_kay())
	{
		// werte des Aktuellen schlssels holen
		pw[0] = init.get_wert_i(0,"x");
		pw[1] = init.get_wert_i(0,"y");
		pw[2] = init.get_wert_i(0,"anz");
		pw[3] = init.get_wert_i(0,"farbe");
		p.neue_particel(pw[0],pw[1],pw[2],pw[3]);
	}

	// Hauptschleife
	bool running = true;
	Uint32 start=0, ende=0, zeit=0;
	int frames=0, allframes=0, schnitt=0;
	char caption[20];
	

	while (running)
	{
		SDL_Event event;
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
			case SDL_KEYDOWN:
				switch(event.key.keysym.sym)
				{
				case SDLK_ESCAPE:running=false;break;
				default: break;
				}
				break;

			case SDL_QUIT:
				running = false;
				break;
			}
		}
		start = SDL_GetTicks();
		
		p.zeichnen();
		
		// Frames pro Sekunde berechnen und anzeigen
		Uint32 ende = SDL_GetTicks();
		Uint32 zeit = ende-start;
		frames=0;
		if (zeit!=0) frames = (1000/zeit);
		allframes+=frames;
		schnitt++;
		if (schnitt==10)
		{
			sprintf(caption,"%d FPS",allframes/schnitt);
			SDL_WM_SetCaption(caption,caption);
			allframes=schnitt=0;
		}

	}

	SDL_Quit();

	return 0;
}